SHEBANG
# Copyright @BABOLO (C)2002,2003
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.2 2004/05/11 11:40:10 yura Exp $

JNTROSTUP(ircservices,,ircservicesdnl
,dnl
# jailup ${inclass} dir jailname jailaddr [user [group [port]]]
#     where jailname - hostname for jail (see jail(2) hostname)
#           jailaddr - IP addr for jail (see jail(2) ip_number)
#           dir relative to ${JAILUPDIR} and ${JAILRODIR}
# 
#                                                   useddnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
user="${4:-10000}"
group="${5:-10000}"
port="${6:-6677}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

${mkdir} "${main_dir}" "${conf_dir}"
${up_mdir} "${main_dir}" ${MTREE}
#${up_mdir} "${main_dir}/usr/services/" ${MTREE}-conf
${up_genlist} helpfiles/ ${MTREE} | ${up_data} "${main_dir}/usr/services/helpfiles/" /usr/local/lib/services/helpfiles/
${up_genlist} languages/ ${MTREE} | ${up_data} "${main_dir}/usr/services/languages/" /usr/local/lib/services/languages/
${up_genlist} modules/ ${MTREE} | ${up_data} "${main_dir}/usr/services/modules/" /usr/local/lib/services/modules/
ETCOPY(host.conf hosts protocols resolv.conf)
${up_shlib} "${main_dir}/usr/lib" << "EOF"
            c 	
EOF

${up_libexe} "${main_dir}/usr/libexec" << EOF
                   /usr/libexec/ld-elf.so.1
                   /usr/local/sbin/ircservices
EOF


      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
if  [ ! -e "${conf_dir}/group" ]; then
    ${cat} << "EOF" > "${conf_dir}/group"
wheel:*:0:root
irc:*:10000:
nogroup:*:65533:
nobody:*:65534:
EOF
fi

if  [ ! -e "${conf_dir}/master.passwd" ]; then
    ${cat} << "EOF" > "${conf_dir}/master.passwd"
root:*:0:0::0:0:Charlie &:/:/nonexistent
irc:*:10000:10000::0:0:ircd server:/:/sbin/nologin
nobody:*:65534:65534::0:0:Unprivileged user:/nonexistent:/nonexistent
EOF
fi

cf="ircservices.conf"; if  [ -e "${conf_dir}/${cf}" ]; then cf="${cf}.sample"; fi
${sed} -e "s|%%ADMINEMAIL%%|${ADMINEMAIL}|" "${TEMPLATE}-server" > "${conf_dir}/${cf}"
cff="modules.conf"; if  [ -e "${conf_dir}/${cff}" ]; then cf="${cff}.sample"; fi
${sed} -e "s|%%ADMINEMAIL%%|${ADMINEMAIL}|" "${TEMPLATE}-modules" > "${conf_dir}/${cff}"

      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${up_mtree} "${main_dir}" ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << "EOF"
/set type=file uname=root gname=wheel mode=0644 flags=none
.				type=dir mode=0755
    group
    host.conf
    hosts
    localtime
    protocols
    resolv.conf
    master.passwd		mode=0600
    ircservices.conf            mode=0666
    modules.conf            mode=0666
..
EOF

${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"


${cat} << EOF >> "${genconfig}"
#${genclass}   ${inclass}      ${jdir} ${jailsname}    ${jailsaddr}    0       ${user} ${group}        ${port}
EOF

      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${cat} << EOF >> "${etcdir}/fstab"
#/null                  ${main_dir}/dev null    ro,noexec       0 0
#${conf_dir}		${main_dir}/etc	null	ro,nodev,noexec	0 0
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
